Subject: Re: Why can download manager can help?

From: Joe Touch <[email-masked]>
Date: Fri, 01 Jun 2001 09:38:54 -0700

Mike Jagdis wrote:
> 
> > Some download managers such as NetAnts claim to be designed to maximize
> > throughput by making multiple HTTP connections, each of which downloads
> > a separate part of a single big file.
> >
> > I wonder why doing this is helpful.
> 
> By violating the slow start principle. With one TCP connection
> you send one packet, get an ACK, send two packets, get two ACKs
> etc. With short lived connections, such as HTTP/1.0, you may never
> actually get out of slow start and thus use significantly less
> then bandwidth than is actually available.
> 
>   HTTP/1.1 addresses this at the application level by by reusing
> the same TCP connection. With a longer lived connection you have
> the chance to ramp up further and get out of slow start.

There are two reasons this helps:

	1. the sequence of items in a single page ramp
	   up the window, rather than restarting it,
	   as Mike indicated

	2. the sender-driven request/response interaction
	   defeats slow-start restart, which should occur
	   during the idle times between the pages.

We had an old ID on this, which we started implementing
and got put aside during some hectic times. We're hoping
to finish it off this summer. Here's a personally archived
version, that describes the situation further:

	http://www.isi.edu/touch/pubs/tcpimpl-restart-01.txt 
 
>   I seem to remember early versions of Netscape used multiple
> connections. I believe you'll find it mentioned in the tcpsat archives
> if you search for netscape and marco.

Most still do - up to 4 or 8 connections between the same endpoint
pairs.

Joe